\section{Implementation}
\label{sec:implementation}
We implement GRT based on the framework of Randoop.
%We discuss the implementation of three components based on external tools.
Constant mining is implemented as an abstract interpreter built on the ASM interpreter 
framework~\cite{Bruneton02asm:a}. It analyzes the Java bytecode of each 
class and performs constant propagation and folding. 
Our analysis is intra-procedural; we forgo a more 
accurate inter-procedural and pointer analysis for performance reasons. 
Using value propagation combined with primitive value fuzzing,
our approach goes beyond value extraction from source code~\cite{conf/kbse/RobinsonEPAL11}. 

We implement Impurity based on the ReIm \& ReImInfer framework~\cite{Huang:2012:RRC:2398857.2384680}
due to its scalability and robustness. This framework does not require an expensive, 
complete analysis of the program. It infers method purity based on the type 
system and by its automatic inference algorithm. Since our impurity component is
probabilistic, a fast while sometimes inaccurate purity analysis fulfills our need.

Bloodhound is implemented by adapting JaCoCo~\cite{Jacoco:2013} to support on-line 
coverage profiling during test generation. 
During class loading, the coverage 
probes are instrumented on the classes under test before each branch or jump instruction, 
so that if the corresponding part of the code is executed at run-time, 
the probe flag will be set.
Coverage is periodically updated based on this information.
Currently, we empirically set parameters of weight formula and time interval
as $p=0.99, \alpha=0.9, t=50$\,seconds~(see section~\ref{subsec:coverage}); we leave
automatic parameter tuning as future work.
